package com.mobvcasting.snapshot;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.Toast;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Bitmap.CompressFormat;
import android.hardware.Camera;

public class SnapShot extends Activity implements OnClickListener, Camera.PictureCallback, HttpFilePosterObserver {

	CameraView cameraView;
	ImageView imv;
	HttpFilePoster poster;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        //setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE); 
        
        setContentView(R.layout.main);
               
        Button pictureButton = (Button) this.findViewById(R.id.Button01);
        imv = (ImageView) this.findViewById(R.id.ImageView01);
        cameraView = (CameraView) this.findViewById(R.id.CameraView01);
        
        Button statusButton = (Button) this.findViewById(R.id.Button02);
        statusButton.setOnClickListener(this);
        
        pictureButton.setOnClickListener(this);
        
    }
    
    // From the OnClickListener
    public void onClick(View v)
    {
    	cameraView.takePicture(null, null, this);
    }
    
    // From the Camera.PictureCallback
    public void onPictureTaken(byte[] data, Camera camera)
    {
		Bitmap bmp = BitmapFactory.decodeByteArray(data, 0, data.length);
		imv.setImageBitmap(bmp);    	
		
		String filename = "apicture.jpg";
        File pictureFile = new File(Environment.getExternalStorageDirectory().getAbsolutePath() + "/" + filename);
        try 
        {
			FileOutputStream pfos = new FileOutputStream(pictureFile);
        	bmp.compress(CompressFormat.JPEG, 75, pfos);

        	pfos.flush();
        	pfos.close();
		} 
        catch (FileNotFoundException e) 
		{
			e.printStackTrace();
		} 
        catch (IOException e) 
        {	
			e.printStackTrace();
		}
        
        poster = new HttpFilePoster("http://yourhost.com/upload.php",filename,"bytes",pictureFile);
        poster.setObserver(this); // We implement HttpFilePosterObserver
        poster.startUpload();
    }

    // HttpFilePosterObserver
	public void statusUpdated(int newStatus) 
	{
		if (newStatus == HttpFilePoster.COMPLETED)
		{
    		Toast t = Toast.makeText(this,"Upload Complete",Toast.LENGTH_LONG);
    		t.show();			
		}
		else if (newStatus == HttpFilePoster.ERROR)
		{
    		Toast t = Toast.makeText(this,"Upload Error " + poster.getServerResponse(),Toast.LENGTH_LONG);
    		t.show();			
			
		}
		else if (newStatus == HttpFilePoster.STARTED)
		{
    		Toast t = Toast.makeText(this,"Upload Started",Toast.LENGTH_LONG);
    		t.show();			
				
		}
	}
}
